package com.fufan.mtsaas.modules.sysmgr.symenu.controller;


import com.alibaba.fastjson.JSONObject;
import com.fufan.mtsaas.modules.common.bo.request.DataRequest;
import com.fufan.mtsaas.modules.common.bo.request.ResultPack;
import com.fufan.mtsaas.modules.common.bo.response.RequestPojo;
import com.fufan.mtsaas.modules.common.bo.response.Result;
import com.fufan.mtsaas.modules.sysmgr.symenu.bo.request.MenuQueryRequest;
import com.fufan.mtsaas.modules.sysmgr.symenu.bo.request.MenuSaveRequest;
import com.fufan.mtsaas.modules.common.bo.request.DataRequest;
import com.fufan.mtsaas.modules.common.bo.request.ResultPack;
import com.fufan.mtsaas.modules.sysmgr.symenu.bo.request.MenuQueryRequest;
import com.fufan.mtsaas.modules.sysmgr.symenu.bo.request.MenuSaveRequest;
import com.fufan.mtsaas.modules.sysmgr.symenu.model.SYmenu;
import com.fufan.mtsaas.modules.common.bo.response.RequestPojo;
import com.fufan.mtsaas.modules.common.bo.response.Result;
import com.fufan.mtsaas.modules.sysmgr.symenu.service.SYmenuSvc;
import com.fufan.mtsaas.modules.sysmgr.syuser.bo.request.UserQueryRequest;
import com.fufan.mtsaas.util.JSonUtil;
import com.fufan.mtsaas.util.ParamUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpSession;
import java.util.Map;

/**
 * <p>
 * 
 * </p>
 *
 * @author Liby
 * @since 2019-08-19
 */
@Slf4j
@Api(tags = "MTSaas：系统管理-菜单信息模块", description = "SYmenu对象接口")
@RestController
@RequestMapping("/SYS/SYmenu")
public class SYmenuCtrl {
    @Autowired
    private SYmenuSvc targetService;

    /**
     * 分页查询
     * */
    @ApiOperation(value = "分页查询所有，根据需要传入分页参数：pageSize每页数量(默认为10)，currentPage当前页数(默认为1)", httpMethod = "POST", produces = "application/json")
    @PostMapping(value ="/doQueryPage")
    public Result<SYmenu> doQueryPage(@RequestBody @ApiIgnore DataRequest dataRequest, MenuQueryRequest request){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        MenuQueryRequest map = JSonUtil.toBean(mapdata.toJSONString(), MenuQueryRequest.class);

        return resultPack.doResultPack(targetService.doQueryPage(map), requestPojo.getIntfId(),requestPojo.getAppKey());
    }

    /**
     * 新增
     * */
    @ApiOperation(value = "新增", httpMethod = "POST", produces = "application/json")
    @RequestMapping(value = "/doSave", method = RequestMethod.POST)
    public Result<SYmenu> doSaveMap(@RequestBody @ApiIgnore DataRequest dataRequest, MenuSaveRequest request, @ApiIgnore HttpSession session){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        MenuSaveRequest map = JSonUtil.toBean(mapdata.toJSONString(), MenuSaveRequest.class);

        return resultPack.doResultPack(targetService.doSaveMap(map, requestPojo),requestPojo.getIntfId(),requestPojo.getAppKey());
    }

    /**
     * 修改
     * */
    @ApiOperation(value = "修改", httpMethod = "PUT", produces = "application/json")
    @RequestMapping(value = "/doUpdate", method = RequestMethod.PUT)
    public Result<SYmenu> doUpdateMap(@RequestBody @ApiIgnore DataRequest dataRequest, MenuQueryRequest request, @ApiIgnore HttpSession session){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        MenuSaveRequest map = JSonUtil.toBean(mapdata.toJSONString(), MenuSaveRequest.class);

        return resultPack.doResultPack(targetService.doUpdateMap(map, requestPojo),requestPojo.getIntfId(),requestPojo.getAppKey());
    }

    /**
     * 删除数据
     * */
    @ApiOperation(value = "删除数据", httpMethod = "DELETE", produces = "application/json")
    @RequestMapping(value = "/doDelete", method = RequestMethod.DELETE)
    public Result doDelete(@RequestBody @ApiIgnore DataRequest dataRequest, MenuQueryRequest request){
        ResultPack resultPack = new ResultPack();
        RequestPojo requestPojo = ParamUtil.doChange();
        JSONObject mapdata = dataRequest.getData().getParam();
        MenuQueryRequest map = JSonUtil.toBean(mapdata.toJSONString(), MenuQueryRequest.class);

        return resultPack.doResultPack(targetService.doDelete(map, requestPojo),requestPojo.getIntfId(),requestPojo.getAppKey());
    }
	
}
